package Top;

import rca :: *;

(* synthesize *)
module mkTop (Empty);

   rule rl1;
      for (Integer ia = 0; ia < 16; ia = ia + 1)
	 for (Integer ib = 0; ib < 16; ib = ib + 1) begin
	    Bit #(4) a = fromInteger (ia);
	    Bit #(4) b = fromInteger (ib);

	    Bit #(5) z = rca (a, b, 0);
	    $display ("%0d + %0d = %0d" , a, b, z);
	 end

      $finish (0);
   endrule

endmodule


/* Alternative for loop:

      for (Bit #(9) ab = 0; ab < 'h_100; ab=ab+1) begin
	 Bit #(4) a = ab [3:0];
	 Bit #(4) b = ab [7:4];

	 Bit #(5) z = rca (a, b, 0);
	 $display ("%0d + %0d = %0d" , a, b, z);
      end

    Note: there'd be a problem with the following:
      for (Bit #(8) ab = 0; ab <= 'h_FF; ab=ab+1) begin
    because the loop condition is always true
    (+1 wraps around to 0 on 8-bit value at 'h_FF)

*/



// ================================================================

endpackage
